Package org.apache.bcel.classfile

# Class Signature

java.lang.Object
org.apache.bcel.classfile.Attribute
org.apache.bcel.classfile.Signature

All Implemented Interfaces:
  `Cloneable`, `Node`

public final class Signature extends Attribute
This class is derived from Attribute and represents a reference to a GJ attribute.

See Also:
  - `Attribute`

- ## Field Summary

  ### Fields inherited from class org.apache.bcel.classfile.Attribute

  `constant_pool, EMPTY_ARRAY, length, name_index, tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Signature(int nameIndex, int length, int signatureIndex, ConstantPool constantPool)`
  `Signature(Signature c)`
  Initialize from another object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `Attribute`
  `copy(ConstantPool constantPool)`
  `void`
  `dump(DataOutputStream file)`
  Dump source file attribute to file stream in binary format.
  `String`
  `getSignature()`
  `int`
  `getSignatureIndex()`
  `static boolean`
  `isActualParameterList(String s)`
  `static boolean`
  `isFormalParameterList(String s)`
  `void`
  `setSignatureIndex(int signatureIndex)`
  `String`
  `toString()`
  `static String`
  `translate(String s)`

  ### Methods inherited from class org.apache.bcel.classfile.Attribute

  `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Signature

    public Signature(int nameIndex, int length, int signatureIndex, ConstantPool constantPool)
    Parameters:
      `nameIndex` - Index in constant pool to CONSTANT_Utf8
      `length` - Content length in bytes
      `signatureIndex` - Index in constant pool to CONSTANT_Utf8
      `constantPool` - Array of constants

  - ### Signature

    public Signature(Signature c)
    Initialize from another object. Note that both objects use the same references (shallow copy). Use clone() for a physical copy.
    Parameters:
      `c` - Source to copy.

- ## Method Details

  - ### isActualParameterList

    public static boolean isActualParameterList(String s)

  - ### isFormalParameterList

    public static boolean isFormalParameterList(String s)

  - ### translate

    public static String translate(String s)

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Attribute`
    Parameters:
      `v` - Visitor object

  - ### copy

    public Attribute copy(ConstantPool constantPool)
    Specified by:
      `copy` in class `Attribute`
    Parameters:
      `constantPool` - constant pool to save.
    Returns:
      deep copy of this attribute

  - ### dump

    public void dump(DataOutputStream file) throws IOException
    Dump source file attribute to file stream in binary format.
    Overrides:
      `dump` in class `Attribute`
    Parameters:
      `file` - Output file stream
    Throws:
      `IOException` - if an I/O error occurs.

  - ### getSignature

    public String getSignature()
    Returns:
      GJ signature.

  - ### getSignatureIndex

    public int getSignatureIndex()
    Returns:
      Index in constant pool of source file name.

  - ### setSignatureIndex

    public void setSignatureIndex(int signatureIndex)
    Parameters:
      `signatureIndex` - the index info the constant pool of this signature

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Attribute`
    Returns:
      String representation